﻿@using SiteGuide.DAL.Models
@using SiteGuide.Service
@using SiteGuide.Web.Helpers
@using Humanizer
@model SiteGuide.Service.EditSummaryModel

<div class="alert alert-primary" role="alert">
    <p>Welcome to the new site editor. This is still in beta. Please send bug reports and feedback to the <a href="mailto:webmaster@siteguide.org.au">webmaster</a>.</p>
    <p>Some functions are still missing, for example uploading of images. You're always welcome to simply email the <a href="mailto:webmaster@siteguide.org.au">webmaster</a> all or some of the changes you require.</p>
</div>

@{
    ViewData["Title"] = Model == null ? "This Edit does not exist." : $"Edit {Model.EditVersion.EditId}";
}

<h1>@ViewData["Title"]</h1>
@if (Model == null)
{
    <span class="badge badge-danger">This Edit does not exist. It may have been abandoned.</span>
}
else
{
    if (Model.EditVersion.StatusId == "A")
    {
        <span class="badge badge-@EditVersionStatusHelper.BootstrapClass(Model.EditVersion.StatusId)">
            Accepted as @*<a asp-controller="Versions" asp-action="Details" asp-route-id="@(Model.AcceptedAsVersion)">*@Version @(Model.AcceptedAsVersion)@*</a>*@@*TODO: May want to only show if user has access to target?*@
        </span>
    }
    else
    {
        <partial name="_EditStatus" for="@Model.EditVersion" />
    }
    @if (Model.EditVersion.StatusId == "A")
    {
        <div class="float-right">
            <a class="btn btn-primary" role="button" asp-controller="Versions" asp-action="Details" asp-route-id="@(Model.AcceptedAsVersion)">Version @(Model.AcceptedAsVersion) Details</a>@*TODO: May want to only show if user has access to target?*@
        </div>
    }
    @if (Model.EditVersion.StatusId == "D" && Model.EditVersion.EditVersionNumber > 1)
    {
        <div class="alert alert-success" role="alert">
            @if (Model.UserPrivileges.IsDraftOwner)
            {
                <h4>You are reviewing this edit</h4>
                <p>You have claimed this edit for review. You can make changes to the edit, accept or reject it, or submit it for further review by others. You have exclusive access to the edit during this time. Please try to finish your review promptly. Alternatively you can submit or abandon your draft review changes to make the edit available to other reviewers.</p>
            }
            else
            {
                <h4>Edit under Review</h4>
                <p>This edit is currently under review.</p>
            }
        </div>
    }
    @foreach (var editVersion in Model.EditVersions)
    {
        @await Html.PartialAsync("_EditVersionHeader", editVersion)
        @if (editVersion.StatusId == "D" 
            ? (Model.UserPrivileges.IsDraftOwner | Model.UserPrivileges.IsSystemAdmin) 
            : Model.UserPrivileges.CanView)
        {
            <ChangeDetails data-node="@editVersion.EditIdAndVersionNumber"
                           data-show-view-buttons="true"
                           data-show-edit-button="@((editVersion.StatusId == "D" && Model.UserPrivileges.IsDraftOwner).ToString().ToLowerInvariant())">
            </ChangeDetails>
        }
        <hr />
    }
    <br />
    <div class="row">
        @foreach (var actionsByRole in Model.PossibleActionsByRole)
        {
            <div class="col-12 pb-4">
                @switch (actionsByRole.Key)
                {
                    case null:
                        <p>
                            You can submit this edit now to be reviewed and approved. You can also abandon (delete) your changes.
                        </p>
                        @foreach (var action in actionsByRole)
                        {
                            <button type="button" data-toggle="modal" data-target="#actionConfirmationModal" data-action="@action.Name" data-bootstrapClass="@(EditActionHelper.BootstrapClass(action))" class="btn btn-@(EditActionHelper.BootstrapClass(action))">@action.Name.Humanize()</button>
                        }
                        break;
                    case EditActionRole.DirectAdmin:
                        <p>
                            The following actions are available through your role as a direct admin.
                        </p>
                        @foreach (var action in actionsByRole)
                        {
                            <button type="button" data-toggle="modal" data-target="#actionConfirmationModal" data-action="@action.Name" data-role="@actionsByRole.Key" data-rolehumanised="@actionsByRole.Key.Humanize(LetterCasing.Title)" data-bootstrapClass="@(EditActionHelper.BootstrapClass(action))" class="btn btn-@(EditActionHelper.BootstrapClass(action))">@action.Name.Humanize()</button>
                        }
                        break;
                    case EditActionRole.IndirectAdmin:
                        <div class="alert alert-warning" role="alert">
                            <h4>Indirect admin override</h4>
                            <p>
                                The following actions are available through your role as an indirect admin.
                                This should not be used for significant content changes, which should be handled by the direct admin(s), for example the club responsible for a site.
                            </p>
                            @foreach (var action in actionsByRole)
                            {
                                <button type="button" data-toggle="modal" data-target="#actionConfirmationModal" data-action="@action.Name" data-role="@actionsByRole.Key" data-rolehumanised="@actionsByRole.Key.Humanize(LetterCasing.Title)" data-bootstrapClass="@(EditActionHelper.BootstrapClass(action))" class="btn btn-@(EditActionHelper.BootstrapClass(action))">@action.Name.Humanize()</button>
                            }
                        </div>
                        break;
                    case EditActionRole.SystemAdmin:
                        <div class="alert alert-warning" role="alert">
                            <h4>System admin override</h4>
                            <p>
                                The following actions are available through your role as a system admin.
                                This should not be used for significant content changes, which should be handled by the direct admin(s), for example the club responsible for a site.
                            </p>
                            @foreach (var action in actionsByRole)
                            {
                                <button type="button" data-toggle="modal" data-target="#actionConfirmationModal" data-action="@action.Name" data-role="@actionsByRole.Key" data-rolehumanised="@actionsByRole.Key.Humanize(LetterCasing.Title)" data-bootstrapClass="@(EditActionHelper.BootstrapClass(action))" class="btn btn-@(EditActionHelper.BootstrapClass(action))">@action.Name.Humanize()</button>
                            }
                        </div>
                        break;

                    default: throw new NotImplementedException();
                }
            </div>

        }

        @*            case "S":
    @if (Model.UserPrivileges.IsDirectAdmin)
    {
    <p>
    As a direct administrator for this change, you may claim this submitted edit for review. Once you do this, you can make changes to the edit, accept or reject it, or submit it for further review by others. You will have exclusive access to the edit during this time, so please try to finish your review promptly.
    </p>
    <button type="submit" value="@EditActions.ClaimForReview.Name as @EditActionRole.DirectAdmin" class="btn btn-success">Claim for Review</button>
    }
    else
    {
    <p>
    This edit is currently awaiting review.
    </p>
    }

    break;*@
    </div>
    @* <hr /> *@
    <div style="font-size:small; display: none;">
        <h3>Debug info</h3>
        <h4>Editors</h4>
        @{
            var editorsByIsDirect = Model.Editors.ToLookup(e => e.MinReasonDistance == 0);
        }
        <h5>Direct</h5>
        <ul>
            @foreach (var editor in editorsByIsDirect[true])
            {
                <li>
                    @editor.ToString()
                    <ul>
                        @foreach (var reason in editor.Reasons)
                        {
                            <li>@reason.ToString()</li>
                        }
                    </ul>
                </li>
            }
        </ul>
        <h5>Indirect</h5>
        <ul>
            @foreach (var editor in editorsByIsDirect[false])
            {
                <li>
                    @editor.ToString()
                    <ul>
                        @foreach (var reason in editor.Reasons)
                        {
                            <li>@reason.ToString()</li>
                        }
                    </ul>
                </li>
            }
        </ul>
        <h5>Partial</h5>
        <ul>
            @foreach (var editor in Model.PartialEditors)
            {
                <li>
                    @editor.ToString()
                    <ul>
                        @foreach (var reason in editor.Reasons)
                        {
                            <li>@reason.ToString()</li>
                        }
                    </ul>
                </li>
            }
        </ul>
        <h4>Full info</h4>
        <pre>@Html.Raw(Newtonsoft.Json.JsonConvert.SerializeObject(Model, Newtonsoft.Json.Formatting.Indented).Replace("\r\n", "<br/>").Replace("  ", "&emsp;"))</pre>
    </div>

    <form method="post" id="actionForm">
        <fieldset>
            <div class="modal fade" id="actionConfirmationModal" tabindex="-1" aria-labelledby="actionConfirmationModalLabel" aria-hidden="true">
                <div class="modal-dialog modal-dialog-centered">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="actionConfirmationModalLabel">Confirm edit action</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <p id="abandonText">
                                @if (Model.EditVersion.EditVersionNumber == 1)
                                {
                                    <text>Are you sure you want to abandon your changes? This cannot be undone.</text>
                                }
                                else
                                {
                                    <text>Are you sure you want to abandon your review changes and make the submitted edit you were reviewing available for review again? This cannot be undone.</text>
                                }
                            </p>
                            <div id="editVersionCommentGroup" class="form-group">
                                <label id="editVersionCommentLabel" for="editVersionComment" class="control-label"></label>
                                <textarea name="editVersionComment" id="editVersionComment" class="form-control"></textarea>
                                <small id="editVersionCommentHelpBlock" class="form-text text-muted">
                                    @if (Model.EditVersion.StatusId == "D" && Model.EditVersion.EditVersionNumber == 1)
                                    {
                                        <text>Please provide a short summary description of your changes and a reason, e.g. "Updated Stanwell Park site rating as per club decision."</text>
                                    }
                                    else
                                    {
                                        <text>Please provide a short summary description of your review, e.g. "Rewrote launch description to fit better with existing style and corrected launch conditions."</text>
                                    }
                                </small>
                                <small id="editVersionCommentHelpBlockRejection" class="form-text text-muted">
                                    Please provide a reason for your rejection of this edit.
                                </small>
                            </div>
                            <div id="versionCommentGroup" class="form-group">
                                <label for="versionComment" class="control-label">Description of changes in this new version</label>
                                <textarea name="versionComment" id="versionComment" class="form-control"></textarea>
                                <small id="versionCommentHelpBlock" class="form-text text-muted">
                                    Please provide a summary description of this change and its reason, e.g. "Updated Stanwell Park site rating as per club decision."
                                </small>
                            </div>
                            <input type="hidden" id="action" name="action" />
                            <input type="hidden" id="role" name="role" />
                        </div>
                        <div class="modal-footer">
                            <button id="actionCancelButton" class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
                            <button id="actionConfirmButton" class="btn btn-primary" type="button" onclick="onSubmit()">
                                <span id="actionConfirmButtonSpinner" class="spinner-border spinner-border-sm" role="status" hidden aria-hidden="true"></span>
                                <span id="actionConfirmButtonText"></span>
                            </button>
                            @*                             <input type="button" id="actionCancelButton" class="btn btn-secondary" data-dismiss="modal" value="Cancel" />
                        <input type="submit" id="actionConfirmButton" class="btn btn-primary" onclick="onSubmit"/>
                        *@
                        </div>
                    </div>
                </div>
            </div>
        </fieldset>
    </form>

    @section Scripts {
    <script src="/js/editSummary.js" asp-append-version="true" async></script>
    }
}
